summaryrefslogtreecommitdiff
path: root/src/share/common
blob: bd887d39b410d333badc6048b08d5e777322ce4b (plain)
  1. # -*-shell-script-*-
  2. # This should be sourced by bash (though we welcome changes to make it POSIX sh compliant)
  3. # Shared sh functions for the monkeysphere
  4. #
  5. # Written by
  6. # Jameson Rollins <jrollins@finestructure.net>
  7. # Jamie McClelland <jm@mayfirst.org>
  8. # Daniel Kahn Gillmor <dkg@fifthhorseman.net>
  9. #
  10. # Copyright 2008-2009, released under the GPL, version 3 or later
  11. # all-caps variables are meant to be user supplied (ie. from config
  12. # file) and are considered global
  13. ########################################################################
  14. ### UTILITY FUNCTIONS
  15. # output version info
  16. version() {
  17. cat "${SYSSHAREDIR}/VERSION"
  18. }
  19. # failure function. exits with code 255, unless specified otherwise.
  20. failure() {
  21. [ "$1" ] && echo "$1" >&2
  22. exit ${2:-'255'}
  23. }
  24. # write output to stderr based on specified LOG_LEVEL the first
  25. # parameter is the priority of the output, and everything else is what
  26. # is echoed to stderr. If there is nothing else, then output comes
  27. # from stdin, and is not prefaced by log prefix.
  28. log() {
  29. local priority
  30. local level
  31. local output
  32. local alllevels
  33. local found=
  34. # don't include SILENT in alllevels: it's handled separately
  35. # list in decreasing verbosity (all caps).
  36. # separate with $IFS explicitly, since we do some fancy footwork
  37. # elsewhere.
  38. alllevels="DEBUG${IFS}VERBOSE${IFS}INFO${IFS}ERROR"
  39. # translate lowers to uppers in global log level
  40. LOG_LEVEL=$(echo "$LOG_LEVEL" | tr "[:lower:]" "[:upper:]")
  41. # just go ahead and return if the log level is silent
  42. if [ "$LOG_LEVEL" = 'SILENT' ] ; then
  43. return
  44. fi
  45. for level in $alllevels ; do
  46. if [ "$LOG_LEVEL" = "$level" ] ; then
  47. found=true
  48. fi
  49. done
  50. if [ -z "$found" ] ; then
  51. # default to INFO:
  52. LOG_LEVEL=INFO
  53. fi
  54. # get priority from first parameter, translating all lower to
  55. # uppers
  56. priority=$(echo "$1" | tr "[:lower:]" "[:upper:]")
  57. shift
  58. # scan over available levels
  59. for level in $alllevels ; do
  60. # output if the log level matches, set output to true
  61. # this will output for all subsequent loops as well.
  62. if [ "$LOG_LEVEL" = "$level" ] ; then
  63. output=true
  64. fi
  65. if [ "$priority" = "$level" -a "$output" = 'true' ] ; then
  66. if [ "$1" ] ; then
  67. echo "$@"
  68. else
  69. cat
  70. fi | sed 's/^/'"${LOG_PREFIX}"'/' >&2
  71. fi
  72. done
  73. }
  74. # run command as monkeysphere user
  75. su_monkeysphere_user() {
  76. # our main goal here is to run the given command as the the
  77. # monkeysphere user, but without prompting for any sort of
  78. # authentication. If this is not possible, we should just fail.
  79. # FIXME: our current implementation is overly restrictive, because
  80. # there may be some su PAM configurations that would allow su
  81. # "$MONKEYSPHERE_USER" -c "$@" to Just Work without prompting,
  82. # allowing specific users to invoke commands which make use of
  83. # this user.
  84. # chpst (from runit) would be nice to use, but we don't want to
  85. # introduce an extra dependency just for this. This may be a
  86. # candidate for re-factoring if we switch implementation languages.
  87. case $(id -un) in
  88. # if monkeysphere user, run the command under bash
  89. "$MONKEYSPHERE_USER")
  90. bash -c "$@"
  91. ;;
  92. # if root, su command as monkeysphere user
  93. 'root')
  94. su "$MONKEYSPHERE_USER" -c "$@"
  95. ;;
  96. # otherwise, fail
  97. *)
  98. log error "non-privileged user."
  99. ;;
  100. esac
  101. }
  102. # cut out all comments(#) and blank lines from standard input
  103. meat() {
  104. grep -v -e "^[[:space:]]*#" -e '^$' "$1"
  105. }
  106. # cut a specified line from standard input
  107. cutline() {
  108. head --line="$1" "$2" | tail -1
  109. }
  110. # make a temporary directory
  111. msmktempdir() {
  112. mktemp -d ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  113. }
  114. # make a temporary file
  115. msmktempfile() {
  116. mktemp ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  117. }
  118. # this is a wrapper for doing lock functions.
  119. #
  120. # it lets us depend on either lockfile-progs (preferred) or procmail's
  121. # lockfile, and should
  122. lock() {
  123. local use_lockfileprogs=true
  124. local action="$1"
  125. local file="$2"
  126. if ! ( type lockfile-create &>/dev/null ) ; then
  127. if ! ( type lockfile &>/dev/null ); then
  128. failure "Neither lockfile-create nor lockfile are in the path!"
  129. fi
  130. use_lockfileprogs=
  131. fi
  132. case "$action" in
  133. create)
  134. if [ -n "$use_lockfileprogs" ] ; then
  135. lockfile-create "$file" || failure "unable to lock '$file'"
  136. else
  137. lockfile -r 20 "${file}.lock" || failure "unable to lock '$file'"
  138. fi
  139. log debug "lock created on '$file'."
  140. ;;
  141. touch)
  142. if [ -n "$use_lockfileprogs" ] ; then
  143. lockfile-touch --oneshot "$file"
  144. else
  145. : Nothing to do here
  146. fi
  147. log debug "lock touched on '$file'."
  148. ;;
  149. remove)
  150. if [ -n "$use_lockfileprogs" ] ; then
  151. lockfile-remove "$file"
  152. else
  153. rm -f "${file}.lock"
  154. fi
  155. log debug "lock removed on '$file'."
  156. ;;
  157. *)
  158. failure "bad argument for lock subfunction '$action'"
  159. esac
  160. }
  161. # for portability, between gnu date and BSD date.
  162. # arguments should be: number longunits format
  163. # e.g. advance_date 20 seconds +%F
  164. advance_date() {
  165. local gnutry
  166. local number="$1"
  167. local longunits="$2"
  168. local format="$3"
  169. local shortunits
  170. # try things the GNU way first
  171. if date -d "$number $longunits" "$format" &>/dev/null; then
  172. date -d "$number $longunits" "$format"
  173. else
  174. # otherwise, convert to (a limited version of) BSD date syntax:
  175. case "$longunits" in
  176. years)
  177. shortunits=y
  178. ;;
  179. months)
  180. shortunits=m
  181. ;;
  182. weeks)
  183. shortunits=w
  184. ;;
  185. days)
  186. shortunits=d
  187. ;;
  188. hours)
  189. shortunits=H
  190. ;;
  191. minutes)
  192. shortunits=M
  193. ;;
  194. seconds)
  195. shortunits=S
  196. ;;
  197. *)
  198. # this is a longshot, and will likely fail; oh well.
  199. shortunits="$longunits"
  200. esac
  201. date "-v+${number}${shortunits}" "$format"
  202. fi
  203. }
  204. # check that characters are in a string (in an AND fashion).
  205. # used for checking key capability
  206. # check_capability capability a [b...]
  207. check_capability() {
  208. local usage
  209. local capcheck
  210. usage="$1"
  211. shift 1
  212. for capcheck ; do
  213. if echo "$usage" | grep -q -v "$capcheck" ; then
  214. return 1
  215. fi
  216. done
  217. return 0
  218. }
  219. # hash of a file
  220. file_hash() {
  221. if type md5sum &>/dev/null ; then
  222. md5sum "$1"
  223. elif type md5 &>/dev/null ; then
  224. md5 "$1"
  225. else
  226. failure "Neither md5sum nor md5 are in the path!"
  227. fi
  228. }
  229. # convert escaped characters in pipeline from gpg output back into
  230. # original character
  231. # FIXME: undo all escape character translation in with-colons gpg
  232. # output
  233. gpg_unescape() {
  234. sed 's/\\x3a/:/g'
  235. }
  236. # convert nasty chars into gpg-friendly form in pipeline
  237. # FIXME: escape everything, not just colons!
  238. gpg_escape() {
  239. sed 's/:/\\x3a/g'
  240. }
  241. # prompt for GPG-formatted expiration, and emit result on stdout
  242. get_gpg_expiration() {
  243. local keyExpire
  244. keyExpire="$1"
  245. if [ -z "$keyExpire" -a "$PROMPT" = 'true' ]; then
  246. cat >&2 <<EOF
  247. Please specify how long the key should be valid.
  248. 0 = key does not expire
  249. <n> = key expires in n days
  250. <n>w = key expires in n weeks
  251. <n>m = key expires in n months
  252. <n>y = key expires in n years
  253. EOF
  254. while [ -z "$keyExpire" ] ; do
  255. read -p "Key is valid for? (0) " keyExpire
  256. if ! test_gpg_expire ${keyExpire:=0} ; then
  257. echo "invalid value" >&2
  258. unset keyExpire
  259. fi
  260. done
  261. elif ! test_gpg_expire "$keyExpire" ; then
  262. failure "invalid key expiration value '$keyExpire'."
  263. fi
  264. echo "$keyExpire"
  265. }
  266. passphrase_prompt() {
  267. local prompt="$1"
  268. local fifo="$2"
  269. local PASS
  270. if [ "$DISPLAY" ] && type "${SSH_ASKPASS:-ssh-askpass}" >/dev/null; then
  271. printf 'Launching "%s"\n' "${SSH_ASKPASS:-ssh-askpass}" | log info
  272. printf '(with prompt "%s")\n' "$prompt" | log debug
  273. "${SSH_ASKPASS:-ssh-askpass}" "$prompt" > "$fifo"
  274. else
  275. read -s -p "$prompt" PASS
  276. # Uses the builtin echo, so should not put the passphrase into
  277. # the process table. I think. --dkg
  278. echo "$PASS" > "$fifo"
  279. fi
  280. }
  281. # remove all lines with specified string from specified file
  282. remove_line() {
  283. local file
  284. local string
  285. local tempfile
  286. file="$1"
  287. string="$2"
  288. if [ -z "$file" -o -z "$string" ] ; then
  289. return 1
  290. fi
  291. if [ ! -e "$file" ] ; then
  292. return 1
  293. fi
  294. # if the string is in the file...
  295. if grep -q -F "$string" "$file" 2>/dev/null ; then
  296. tempfile=$(mktemp "${file}.XXXXXXX") || \
  297. failure "Unable to make temp file '${file}.XXXXXXX'"
  298. # remove the line with the string, and return 0
  299. grep -v -F "$string" "$file" >"$tempfile"
  300. cat "$tempfile" > "$file"
  301. rm "$tempfile"
  302. return 0
  303. # otherwise return 1
  304. else
  305. return 1
  306. fi
  307. }
  308. # remove all lines with MonkeySphere strings in file
  309. remove_monkeysphere_lines() {
  310. local file
  311. local tempfile
  312. file="$1"
  313. # return error if file does not exist
  314. if [ ! -e "$file" ] ; then
  315. return 1
  316. fi
  317. # just return ok if the file is empty, since there aren't any
  318. # lines to remove
  319. if [ ! -s "$file" ] ; then
  320. return 0
  321. fi
  322. tempfile=$(mktemp "${file}.XXXXXXX") || \
  323. failure "Could not make temporary file '${file}.XXXXXXX'."
  324. egrep -v '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$' \
  325. "$file" >"$tempfile"
  326. cat "$tempfile" > "$file"
  327. rm "$tempfile"
  328. }
  329. # translate ssh-style path variables %h and %u
  330. translate_ssh_variables() {
  331. local uname
  332. local home
  333. uname="$1"
  334. path="$2"
  335. # get the user's home directory
  336. userHome=$(get_homedir "$uname")
  337. # translate '%u' to user name
  338. path=${path/\%u/"$uname"}
  339. # translate '%h' to user home directory
  340. path=${path/\%h/"$userHome"}
  341. echo "$path"
  342. }
  343. # test that a string to conforms to GPG's expiration format
  344. test_gpg_expire() {
  345. echo "$1" | egrep -q "^[0-9]+[mwy]?$"
  346. }
  347. # check that a file is properly owned, and that all it's parent
  348. # directories are not group/other writable
  349. check_key_file_permissions() {
  350. local uname
  351. local path
  352. local stat
  353. local access
  354. local gAccess
  355. local oAccess
  356. # function to check that the given permission corresponds to writability
  357. is_write() {
  358. [ "$1" = "w" ]
  359. }
  360. uname="$1"
  361. path="$2"
  362. log debug "checking path permission '$path'..."
  363. # rewrite path if it points to a symlink
  364. if [ -h "$path" ] ; then
  365. path=$(readlink -f "$path")
  366. log debug "checking path symlink '$path'..."
  367. fi
  368. # return 255 if cannot stat file
  369. if ! stat=$(ls -ld "$path" 2>/dev/null) ; then
  370. log error "could not stat path '$path'."
  371. return 255
  372. fi
  373. owner=$(echo "$stat" | awk '{ print $3 }')
  374. gAccess=$(echo "$stat" | cut -c6)
  375. oAccess=$(echo "$stat" | cut -c9)
  376. # return 1 if path has invalid owner
  377. if [ "$owner" != "$uname" -a "$owner" != 'root' ] ; then
  378. log error "improper ownership on path '$path':"
  379. log error " $owner != ($uname|root)"
  380. return 1
  381. fi
  382. # return 2 if path has group or other writability
  383. if is_write "$gAccess" || is_write "$oAccess" ; then
  384. log error "improper group or other writability on path '$path':"
  385. log error " group: $gAccess, other: $oAccess"
  386. return 2
  387. fi
  388. # return zero if all clear, or go to next path
  389. if [ "$path" = '/' ] ; then
  390. log debug "path ok."
  391. return 0
  392. else
  393. check_key_file_permissions "$uname" $(dirname "$path")
  394. fi
  395. }
  396. # return a list of all users on the system
  397. list_users() {
  398. if type getent &>/dev/null ; then
  399. # for linux and FreeBSD systems
  400. getent passwd | cut -d: -f1
  401. elif type dscl &>/dev/null ; then
  402. # for Darwin systems
  403. dscl localhost -list /Search/Users
  404. else
  405. failure "Neither getent or dscl is in the path! Could not determine list of users."
  406. fi
  407. }
  408. # return the path to the home directory of a user
  409. get_homedir() {
  410. local uname=${1:-`whoami`}
  411. eval "echo ~${uname}"
  412. }
  413. ### CONVERSION UTILITIES
  414. # output the ssh key for a given key ID
  415. gpg2ssh() {
  416. local keyID
  417. keyID="$1"
  418. gpg --export "$keyID" | openpgp2ssh "$keyID" 2>/dev/null
  419. }
  420. # output known_hosts line from ssh key
  421. ssh2known_hosts() {
  422. local host
  423. local port
  424. local key
  425. # FIXME this does not properly deal with IPv6 hosts using the
  426. # standard port (because it's unclear whether their final
  427. # colon-delimited address section is a port number or an address
  428. # string)
  429. host=${1%:*}
  430. port=${1##*:}
  431. key="$2"
  432. # specify the host and port properly for new ssh known_hosts
  433. # format
  434. if [ "$port" != "$host" ] ; then
  435. host="[${host}]:${port}"
  436. fi
  437. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  438. }
  439. # output authorized_keys line from ssh key
  440. ssh2authorized_keys() {
  441. local userID
  442. local key
  443. userID="$1"
  444. key="$2"
  445. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  446. }
  447. # convert key from gpg to ssh known_hosts format
  448. gpg2known_hosts() {
  449. local host
  450. local keyID
  451. local key
  452. host="$1"
  453. keyID="$2"
  454. key=$(gpg2ssh "$keyID")
  455. # NOTE: it seems that ssh-keygen -R removes all comment fields from
  456. # all lines in the known_hosts file. why?
  457. # NOTE: just in case, the COMMENT can be matched with the
  458. # following regexp:
  459. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  460. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  461. }
  462. # convert key from gpg to ssh authorized_keys format
  463. gpg2authorized_keys() {
  464. local userID
  465. local keyID
  466. local key
  467. userID="$1"
  468. keyID="$2"
  469. key=$(gpg2ssh "$keyID")
  470. # NOTE: just in case, the COMMENT can be matched with the
  471. # following regexp:
  472. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  473. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  474. }
  475. ### GPG UTILITIES
  476. # retrieve all keys with given user id from keyserver
  477. # FIXME: need to figure out how to retrieve all matching keys
  478. # (not just first N (5 in this case))
  479. gpg_fetch_userid() {
  480. local returnCode=0
  481. local userID
  482. if [ "$CHECK_KEYSERVER" != 'true' ] ; then
  483. return 0
  484. fi
  485. userID="$1"
  486. log verbose " checking keyserver $KEYSERVER... "
  487. echo 1,2,3,4,5 | \
  488. gpg --quiet --batch --with-colons \
  489. --command-fd 0 --keyserver "$KEYSERVER" \
  490. --search ="$userID" &>/dev/null
  491. returnCode="$?"
  492. return "$returnCode"
  493. }
  494. ########################################################################
  495. ### PROCESSING FUNCTIONS
  496. # userid and key policy checking
  497. # the following checks policy on the returned keys
  498. # - checks that full key has appropriate valididy (u|f)
  499. # - checks key has specified capability (REQUIRED_*_KEY_CAPABILITY)
  500. # - checks that requested user ID has appropriate validity
  501. # (see /usr/share/doc/gnupg/DETAILS.gz)
  502. # output is one line for every found key, in the following format:
  503. #
  504. # flag:sshKey
  505. #
  506. # "flag" is an acceptability flag, 0 = ok, 1 = bad
  507. # "sshKey" is the translated gpg key
  508. #
  509. # all log output must go to stderr, as stdout is used to pass the
  510. # flag:sshKey to the calling function.
  511. #
  512. # expects global variable: "MODE"
  513. process_user_id() {
  514. local returnCode=0
  515. local userID
  516. local requiredCapability
  517. local requiredPubCapability
  518. local gpgOut
  519. local type
  520. local validity
  521. local keyid
  522. local uidfpr
  523. local usage
  524. local keyOK
  525. local uidOK
  526. local lastKey
  527. local lastKeyOK
  528. local fingerprint
  529. userID="$1"
  530. # set the required key capability based on the mode
  531. if [ "$MODE" = 'known_hosts' ] ; then
  532. requiredCapability="$REQUIRED_HOST_KEY_CAPABILITY"
  533. elif [ "$MODE" = 'authorized_keys' ] ; then
  534. requiredCapability="$REQUIRED_USER_KEY_CAPABILITY"
  535. fi
  536. requiredPubCapability=$(echo "$requiredCapability" | tr "[:lower:]" "[:upper:]")
  537. # fetch the user ID if necessary/requested
  538. gpg_fetch_userid "$userID"
  539. # output gpg info for (exact) userid and store
  540. gpgOut=$(gpg --list-key --fixed-list-mode --with-colon \
  541. --with-fingerprint --with-fingerprint \
  542. ="$userID" 2>/dev/null) || returnCode="$?"
  543. # if the gpg query return code is not 0, return 1
  544. if [ "$returnCode" -ne 0 ] ; then
  545. log verbose " no primary keys found."
  546. return 1
  547. fi
  548. # loop over all lines in the gpg output and process.
  549. echo "$gpgOut" | cut -d: -f1,2,5,10,12 | \
  550. while IFS=: read -r type validity keyid uidfpr usage ; do
  551. # process based on record type
  552. case $type in
  553. 'pub') # primary keys
  554. # new key, wipe the slate
  555. keyOK=
  556. uidOK=
  557. lastKey=pub
  558. lastKeyOK=
  559. fingerprint=
  560. log verbose " primary key found: $keyid"
  561. # if overall key is not valid, skip
  562. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  563. log debug " - unacceptable primary key validity ($validity)."
  564. continue
  565. fi
  566. # if overall key is disabled, skip
  567. if check_capability "$usage" 'D' ; then
  568. log debug " - key disabled."
  569. continue
  570. fi
  571. # if overall key capability is not ok, skip
  572. if ! check_capability "$usage" $requiredPubCapability ; then
  573. log debug " - unacceptable primary key capability ($usage)."
  574. continue
  575. fi
  576. # mark overall key as ok
  577. keyOK=true
  578. # mark primary key as ok if capability is ok
  579. if check_capability "$usage" $requiredCapability ; then
  580. lastKeyOK=true
  581. fi
  582. ;;
  583. 'uid') # user ids
  584. if [ "$lastKey" != pub ] ; then
  585. log verbose " ! got a user ID after a sub key?! user IDs should only follow primary keys!"
  586. continue
  587. fi
  588. # if an acceptable user ID was already found, skip
  589. if [ "$uidOK" = 'true' ] ; then
  590. continue
  591. fi
  592. # if the user ID does matches...
  593. if [ "$(echo "$uidfpr" | gpg_unescape)" = "$userID" ] ; then
  594. # and the user ID validity is ok
  595. if [ "$validity" = 'u' -o "$validity" = 'f' ] ; then
  596. # mark user ID acceptable
  597. uidOK=true
  598. else
  599. log debug " - unacceptable user ID validity ($validity)."
  600. fi
  601. else
  602. continue
  603. fi
  604. # output a line for the primary key
  605. # 0 = ok, 1 = bad
  606. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  607. log verbose " * acceptable primary key."
  608. if [ -z "$sshKey" ] ; then
  609. log error " ! primary key could not be translated (not RSA?)."
  610. else
  611. echo "0:${sshKey}"
  612. fi
  613. else
  614. log debug " - unacceptable primary key."
  615. if [ -z "$sshKey" ] ; then
  616. log debug " ! primary key could not be translated (not RSA?)."
  617. else
  618. echo "1:${sshKey}"
  619. fi
  620. fi
  621. ;;
  622. 'sub') # sub keys
  623. # unset acceptability of last key
  624. lastKey=sub
  625. lastKeyOK=
  626. fingerprint=
  627. # don't bother with sub keys if the primary key is not valid
  628. if [ "$keyOK" != true ] ; then
  629. continue
  630. fi
  631. # don't bother with sub keys if no user ID is acceptable:
  632. if [ "$uidOK" != true ] ; then
  633. continue
  634. fi
  635. # if sub key validity is not ok, skip
  636. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  637. log debug " - unacceptable sub key validity ($validity)."
  638. continue
  639. fi
  640. # if sub key capability is not ok, skip
  641. if ! check_capability "$usage" $requiredCapability ; then
  642. log debug " - unacceptable sub key capability ($usage)."
  643. continue
  644. fi
  645. # mark sub key as ok
  646. lastKeyOK=true
  647. ;;
  648. 'fpr') # key fingerprint
  649. fingerprint="$uidfpr"
  650. sshKey=$(gpg2ssh "$fingerprint")
  651. # if the last key was the pub key, skip
  652. if [ "$lastKey" = pub ] ; then
  653. continue
  654. fi
  655. # output a line for the sub key
  656. # 0 = ok, 1 = bad
  657. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  658. log verbose " * acceptable sub key."
  659. if [ -z "$sshKey" ] ; then
  660. log error " ! sub key could not be translated (not RSA?)."
  661. else
  662. echo "0:${sshKey}"
  663. fi
  664. else
  665. log debug " - unacceptable sub key."
  666. if [ -z "$sshKey" ] ; then
  667. log debug " ! sub key could not be translated (not RSA?)."
  668. else
  669. echo "1:${sshKey}"
  670. fi
  671. fi
  672. ;;
  673. esac
  674. done | sort -t: -k1 -n -r
  675. # NOTE: this last sort is important so that the "good" keys (key
  676. # flag '0') come last. This is so that they take precedence when
  677. # being processed in the key files over "bad" keys (key flag '1')
  678. }
  679. # process a single host in the known_host file
  680. process_host_known_hosts() {
  681. local host
  682. local userID
  683. local noKey=
  684. local nKeys
  685. local nKeysOK
  686. local ok
  687. local sshKey
  688. local tmpfile
  689. # set the key processing mode
  690. export MODE='known_hosts'
  691. host="$1"
  692. userID="ssh://${host}"
  693. log verbose "processing: $host"
  694. nKeys=0
  695. nKeysOK=0
  696. IFS=$'\n'
  697. for line in $(process_user_id "${userID}") ; do
  698. # note that key was found
  699. nKeys=$((nKeys+1))
  700. ok=$(echo "$line" | cut -d: -f1)
  701. sshKey=$(echo "$line" | cut -d: -f2)
  702. if [ -z "$sshKey" ] ; then
  703. continue
  704. fi
  705. # remove any old host key line, and note if removed nothing is
  706. # removed
  707. remove_line "$KNOWN_HOSTS" "$sshKey" || noKey=true
  708. # if key OK, add new host line
  709. if [ "$ok" -eq '0' ] ; then
  710. # note that key was found ok
  711. nKeysOK=$((nKeysOK+1))
  712. # hash if specified
  713. if [ "$HASH_KNOWN_HOSTS" = 'true' ] ; then
  714. # FIXME: this is really hackish cause ssh-keygen won't
  715. # hash from stdin to stdout
  716. tmpfile=$(mktemp ${TMPDIR:-/tmp}/tmp.XXXXXXXXXX)
  717. ssh2known_hosts "$host" "$sshKey" > "$tmpfile"
  718. ssh-keygen -H -f "$tmpfile" 2>/dev/null
  719. cat "$tmpfile" >> "$KNOWN_HOSTS"
  720. rm -f "$tmpfile" "${tmpfile}.old"
  721. else
  722. ssh2known_hosts "$host" "$sshKey" >> "$KNOWN_HOSTS"
  723. fi
  724. # log if this is a new key to the known_hosts file
  725. if [ "$noKey" ] ; then
  726. log info "* new key for $host added to known_hosts file."
  727. fi
  728. fi
  729. done
  730. # if at least one key was found...
  731. if [ "$nKeys" -gt 0 ] ; then
  732. # if ok keys were found, return 0
  733. if [ "$nKeysOK" -gt 0 ] ; then
  734. return 0
  735. # else return 2
  736. else
  737. return 2
  738. fi
  739. # if no keys were found, return 1
  740. else
  741. return 1
  742. fi
  743. }
  744. # update the known_hosts file for a set of hosts listed on command
  745. # line
  746. update_known_hosts() {
  747. local returnCode=0
  748. local nHosts
  749. local nHostsOK
  750. local nHostsBAD
  751. local fileCheck
  752. local host
  753. # the number of hosts specified on command line
  754. nHosts="$#"
  755. nHostsOK=0
  756. nHostsBAD=0
  757. # touch the known_hosts file so that the file permission check
  758. # below won't fail upon not finding the file
  759. (umask 0022 && touch "$KNOWN_HOSTS")
  760. # check permissions on the known_hosts file path
  761. check_key_file_permissions $(whoami) "$KNOWN_HOSTS" || failure
  762. # create a lockfile on known_hosts:
  763. lock create "$KNOWN_HOSTS"
  764. # FIXME: we're discarding any pre-existing EXIT trap; is this bad?
  765. trap "lock remove $KNOWN_HOSTS" EXIT
  766. # note pre update file checksum
  767. fileCheck="$(file_hash "$KNOWN_HOSTS")"
  768. for host ; do
  769. # process the host
  770. process_host_known_hosts "$host" || returnCode="$?"
  771. # note the result
  772. case "$returnCode" in
  773. 0)
  774. nHostsOK=$((nHostsOK+1))
  775. ;;
  776. 2)
  777. nHostsBAD=$((nHostsBAD+1))
  778. ;;
  779. esac
  780. # touch the lockfile, for good measure.
  781. lock touch "$KNOWN_HOSTS"
  782. done
  783. # remove the lockfile and the trap
  784. lock remove "$KNOWN_HOSTS"
  785. trap - EXIT
  786. # note if the known_hosts file was updated
  787. if [ "$(file_hash "$KNOWN_HOSTS")" != "$fileCheck" ] ; then
  788. log debug "known_hosts file updated."
  789. fi
  790. # if an acceptable host was found, return 0
  791. if [ "$nHostsOK" -gt 0 ] ; then
  792. return 0
  793. # else if no ok hosts were found...
  794. else
  795. # if no bad host were found then no hosts were found at all,
  796. # and return 1
  797. if [ "$nHostsBAD" -eq 0 ] ; then
  798. return 1
  799. # else if at least one bad host was found, return 2
  800. else
  801. return 2
  802. fi
  803. fi
  804. }
  805. # process hosts from a known_hosts file
  806. process_known_hosts() {
  807. local hosts
  808. # exit if the known_hosts file does not exist
  809. if [ ! -e "$KNOWN_HOSTS" ] ; then
  810. failure "known_hosts file '$KNOWN_HOSTS' does not exist."
  811. fi
  812. log debug "processing known_hosts file:"
  813. log debug " $KNOWN_HOSTS"
  814. hosts=$(meat "$KNOWN_HOSTS" | cut -d ' ' -f 1 | grep -v '^|.*$' | tr , ' ' | tr '\n' ' ')
  815. if [ -z "$hosts" ] ; then
  816. log debug "no hosts to process."
  817. return
  818. fi
  819. # take all the hosts from the known_hosts file (first
  820. # field), grep out all the hashed hosts (lines starting
  821. # with '|')...
  822. update_known_hosts $hosts
  823. }
  824. # process uids for the authorized_keys file
  825. process_uid_authorized_keys() {
  826. local userID
  827. local nKeys
  828. local nKeysOK
  829. local ok
  830. local sshKey
  831. # set the key processing mode
  832. export MODE='authorized_keys'
  833. userID="$1"
  834. log verbose "processing: $userID"
  835. nKeys=0
  836. nKeysOK=0
  837. IFS=$'\n'
  838. for line in $(process_user_id "$userID") ; do
  839. # note that key was found
  840. nKeys=$((nKeys+1))
  841. ok=$(echo "$line" | cut -d: -f1)
  842. sshKey=$(echo "$line" | cut -d: -f2)
  843. if [ -z "$sshKey" ] ; then
  844. continue
  845. fi
  846. # remove the old host key line
  847. remove_line "$AUTHORIZED_KEYS" "$sshKey"
  848. # if key OK, add new host line
  849. if [ "$ok" -eq '0' ] ; then
  850. # note that key was found ok
  851. nKeysOK=$((nKeysOK+1))
  852. ssh2authorized_keys "$userID" "$sshKey" >> "$AUTHORIZED_KEYS"
  853. fi
  854. done
  855. # if at least one key was found...
  856. if [ "$nKeys" -gt 0 ] ; then
  857. # if ok keys were found, return 0
  858. if [ "$nKeysOK" -gt 0 ] ; then
  859. return 0
  860. # else return 2
  861. else
  862. return 2
  863. fi
  864. # if no keys were found, return 1
  865. else
  866. return 1
  867. fi
  868. }
  869. # update the authorized_keys files from a list of user IDs on command
  870. # line
  871. update_authorized_keys() {
  872. local returnCode=0
  873. local userID
  874. local nIDs
  875. local nIDsOK
  876. local nIDsBAD
  877. local fileCheck
  878. # the number of ids specified on command line
  879. nIDs="$#"
  880. nIDsOK=0
  881. nIDsBAD=0
  882. log debug "updating authorized_keys file:"
  883. log debug " $AUTHORIZED_KEYS"
  884. # check permissions on the authorized_keys file path
  885. check_key_file_permissions $(whoami) "$AUTHORIZED_KEYS" || failure
  886. # create a lockfile on authorized_keys
  887. lock create "$AUTHORIZED_KEYS"
  888. # FIXME: we're discarding any pre-existing EXIT trap; is this bad?
  889. trap "lock remove $AUTHORIZED_KEYS" EXIT
  890. # note pre update file checksum
  891. fileCheck="$(file_hash "$AUTHORIZED_KEYS")"
  892. # remove any monkeysphere lines from authorized_keys file
  893. remove_monkeysphere_lines "$AUTHORIZED_KEYS"
  894. for userID ; do
  895. # process the user ID, change return code if key not found for
  896. # user ID
  897. process_uid_authorized_keys "$userID" || returnCode="$?"
  898. # note the result
  899. case "$returnCode" in
  900. 0)
  901. nIDsOK=$((nIDsOK+1))
  902. ;;
  903. 2)
  904. nIDsBAD=$((nIDsBAD+1))
  905. ;;
  906. esac
  907. # touch the lockfile, for good measure.
  908. lock touch "$AUTHORIZED_KEYS"
  909. done
  910. # remove the lockfile and the trap
  911. lock remove "$AUTHORIZED_KEYS"
  912. # remove the trap
  913. trap - EXIT
  914. # note if the authorized_keys file was updated
  915. if [ "$(file_hash "$AUTHORIZED_KEYS")" != "$fileCheck" ] ; then
  916. log debug "authorized_keys file updated."
  917. fi
  918. # if an acceptable id was found, return 0
  919. if [ "$nIDsOK" -gt 0 ] ; then
  920. return 0
  921. # else if no ok ids were found...
  922. else
  923. # if no bad ids were found then no ids were found at all, and
  924. # return 1
  925. if [ "$nIDsBAD" -eq 0 ] ; then
  926. return 1
  927. # else if at least one bad id was found, return 2
  928. else
  929. return 2
  930. fi
  931. fi
  932. }
  933. # process an authorized_user_ids file for authorized_keys
  934. process_authorized_user_ids() {
  935. local line
  936. local nline
  937. local userIDs
  938. authorizedUserIDs="$1"
  939. # exit if the authorized_user_ids file is empty
  940. if [ ! -e "$authorizedUserIDs" ] ; then
  941. failure "authorized_user_ids file '$authorizedUserIDs' does not exist."
  942. fi
  943. log debug "processing authorized_user_ids file:"
  944. log debug " $authorizedUserIDs"
  945. # check permissions on the authorized_user_ids file path
  946. check_key_file_permissions $(whoami) "$authorizedUserIDs" || failure
  947. if ! meat "$authorizedUserIDs" >/dev/null ; then
  948. log debug " no user IDs to process."
  949. return
  950. fi
  951. nline=0
  952. # extract user IDs from authorized_user_ids file
  953. IFS=$'\n'
  954. for line in $(meat "$authorizedUserIDs") ; do
  955. userIDs["$nline"]="$line"
  956. nline=$((nline+1))
  957. done
  958. update_authorized_keys "${userIDs[@]}"
  959. }
  960. # takes a gpg key or keys on stdin, and outputs a list of
  961. # fingerprints, one per line:
  962. list_primary_fingerprints() {
  963. local fake=$(msmktempdir)
  964. GNUPGHOME="$fake" gpg --no-tty --quiet --import
  965. GNUPGHOME="$fake" gpg --with-colons --fingerprint --list-keys | \
  966. awk -F: '/^fpr:/{ print $10 }'
  967. rm -rf "$fake"
  968. }
  969. check_cruft_file() {
  970. local loc="$1"
  971. local version="$2"
  972. if [ -e "$loc" ] ; then
  973. printf "! The file '%s' is no longer used by\n monkeysphere (as of version %s), and can be removed.\n\n" "$loc" "$version" | log info
  974. fi
  975. }
  976. check_upgrade_dir() {
  977. local loc="$1"
  978. local version="$2"
  979. if [ -d "$loc" ] ; then
  980. printf "The presence of directory '%s' indicates that you have\nnot yet completed a monkeysphere upgrade.\nYou should probably run the following script:\n %s/transitions/%s\n\n" "$loc" "$SYSSHAREDIR" "$version" | log info
  981. fi
  982. }
  983. ## look for cruft from old versions of the monkeysphere, and notice if
  984. ## upgrades have not been run:
  985. report_cruft() {
  986. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-host" 0.23
  987. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-authentication" 0.23
  988. check_cruft_file "${SYSCONFIGDIR}/gnupg-authentication.conf" 0.23
  989. check_cruft_file "${SYSCONFIGDIR}/gnupg-host.conf" 0.23
  990. local found=
  991. for foo in "${SYSDATADIR}/backup-from-"*"-transition" ; do
  992. if [ -d "$foo" ] ; then
  993. printf "! %s\n" "$foo" | log info
  994. found=true
  995. fi
  996. done
  997. if [ "$found" ] ; then
  998. printf "The directories above are backups left over from a monkeysphere transition.\nThey may contain copies of sensitive data (host keys, certifier lists), but\nthey are no longer needed by monkeysphere.\nYou may remove them at any time.\n\n" | log info
  999. fi
  1000. }